<script setup lang="ts">
    import { computed, ComputedRef, ref, toValue, watchEffect } from 'vue'
    import SImageCollectionEditor from '@/shared/document/components/SImageCollectionEditor.vue'
    import SInterventionForm from '@/interventionServiceOffer/components/intervention/SInterventionForm.vue'
    import { requiredInject } from '@/shared/helpers/types'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import { readonly } from 'vue'
    import { Intervention } from '@/interventionServiceOffer/entities/intervention/Intervention'
    import { InterventionApi } from '@/interventionServiceOffer/entities/intervention/InterventionApi'
    import { interventionMapper } from '@/interventionServiceOffer/entities/intervention/InterventionMapper'

    interface Props {
        interventionOriginale: Intervention
    }

    const props = defineProps<Props>()

    const intervention = ref<Intervention>(
        toValue(props.interventionOriginale.clone())
    )

    watchEffect(() => {
        intervention.value = props.interventionOriginale.clone()
    })

    const addedImagesAvantB64 = ref<string[]>([])
    const removedExistingImagesAvantId = ref<string[]>([])
    const addedImagesAprèsB64 = ref<string[]>([])
    const removedExistingImagesAprèsId = ref<string[]>([])

    const msal = useMsal()
    const interventionApi = new InterventionApi(msal)
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const isProcessing = ref<boolean>(false)
    const isDirty = computed(() => {
        return !intervention.value.equals(props.interventionOriginale)
    })

    async function mettreÀJourIntervention() {
        isProcessing.value = true
        try {
            const interventionDto = interventionMapper.toEditDto(
                intervention.value
            )

            await interventionApi.deleteImages(
                serviceOfferId.value,
                props.interventionOriginale.id,
                removedExistingImagesAvantId.value,
                'images-avant'
            )
            await interventionApi.addImages(
                serviceOfferId.value,
                props.interventionOriginale.id,
                addedImagesAvantB64.value,
                'images-avant'
            )
            await interventionApi.deleteImages(
                serviceOfferId.value,
                props.interventionOriginale.id,
                removedExistingImagesAprèsId.value,
                'images-apres'
            )
            await interventionApi.addImages(
                serviceOfferId.value,
                props.interventionOriginale.id,
                addedImagesAprèsB64.value,
                'images-apres'
            )

            const updatedIntervention = await interventionApi.update(
                serviceOfferId.value,
                props.interventionOriginale.id,
                interventionDto
            )

            return updatedIntervention
        } finally {
            isProcessing.value = false
        }
    }

    const interventionFormRef = ref<InstanceType<
        typeof SInterventionForm
    > | null>(null)
    const formFieldsAreValid: ComputedRef<boolean> = computed(() => {
        return !!interventionFormRef.value?.formFieldsAreValid
    })

    defineExpose({
        mettreÀJourIntervention,
        formFieldsAreValid: readonly(formFieldsAreValid),
        isProcessing: readonly(isProcessing),
        isDirty: readonly(isDirty),
    })
</script>

<template>
    <v-row data-cy="card-modification-intervention">
        <v-col cols="12">
            <h6 class="text-h6">Photos avant l'intervention</h6>
            <s-image-collection-editor
                v-model:added-images-b64="addedImagesAvantB64"
                v-model:removed-existing-images-id="
                    removedExistingImagesAvantId
                "
                v-model:existing-images="intervention.imagesAvant"
            />
        </v-col>
        <v-col cols="12">
            <h6 class="text-h6">Photos après l'intervention</h6>
            <s-image-collection-editor
                v-model:added-images-b64="addedImagesAprèsB64"
                v-model:removed-existing-images-id="
                    removedExistingImagesAprèsId
                "
                v-model:existing-images="intervention.imagesApres"
            />
        </v-col>
        <v-col cols="12">
            <s-intervention-form
                ref="interventionFormRef"
                v-model="intervention"
                :available-equipements="
                    intervention.relatedEquipement
                        ? [intervention.relatedEquipement]
                        : []
                "
            />
        </v-col>
    </v-row>
</template>
